/***************************************************************************************
 *
 *  IMPORTANT: READ BEFORE DOWNLOADING, COPYING, INSTALLING OR USING.
 *
 *  By downloading, copying, installing or using the software you agree to this license.
 *  If you do not agree to this license, do not download, install, 
 *  copy or use the software.
 *
 *  Copyright (C) 2010-2014, HappyTime Corporation, all rights reserved.
 *
 *  Any copying, transferring or any other usage is prohibited.
 *
****************************************************************************************/

#ifndef PPCLIENT_H
#define PPCLIENT_H

#include <QtCore/QtGlobal>
#if (QT_VERSION >= QT_VERSION_CHECK(5, 1, 0))
#include <QtWidgets/QDialog>
#else
#include <QtGui/QDialog>
#endif
#include <QtCore/QMutex>
#include "ui_ppclient.h"


typedef struct
{
    void *  sua;
    void *  pdata;
    int     len;
} PPDATA;

typedef QVector<PPDATA> PPDATASEQ;

class ppclient : public QDialog
{
	Q_OBJECT

public:
    ppclient(QWidget *parent = 0, Qt::WindowFlags flags = 0);
	~ppclient();

	void onNotify(int evt, void *sua, void * p_ctx, int len);
	void onData(void * sua, void * p_data, int len);
	
private slots:
	void slotRegister();
	void slotSend();
	void slotConnect();
	void slotDisconnect();
	void slotNotify(int evt, void *sua, void * p_ctx, int len);
	void slotDataReady();
	
signals:
	void notify(int evt, void *sua, void * p_ctx, int len);
    void dataReady();
    
private:
	void initDialog();
	void connSignalSlot();

private:
	Ui::ppclient ui;

	void * 		m_psua;
	
	QMutex 		m_mutex;	
	PPDATASEQ 	m_dataSeq;
};

#endif // PPCLIENT_H


